define([
        "dojo/_base/declare",
        "dojo/_base/lang",
        "dojo/_base/xhr", 
        "dojo/store/JsonRest" 
        ],
	function (declare, lang, xhr, JsonRest){
	
	return declare("cognos.update.ContentStoreJsonRest",
			[JsonRest], {
		
		subpath: "/*[permission('write')][@shown='true'][@objectClass='package' or @objectClass='folder' or @objectClass='report']",
		 
		constructor: function(/*dojo.store.JsonRest*/ options){
			
	    	options = options || {}; 
		
			this.campassport = options.campassport || "MTsxMTE6NDc2Y2Q5ZGQtMWZiOC03NWQ4LWE2YmQtMGM4MDQ0YzUxMjA2OjI4MTc5MjQwNzg7MDszOzA7";
	
			this.root = {
					id: 0,
					name: "Content Store",
					type:"folder",
					children: true
				}; 	
		},
		
		mayHaveChildren: function(object){
			// see if it has a children property
			return "children" in object;
		},
		
		getChildren: function(object, onComplete, onError){ 
			
			if(object.id=="0" && object.name=="Content Store") {
				this.root.children = [];
				
				this.get("")
					.then(function(data){  
						for(var i=0;i<data.length;i++){
							object.children.push (data[i]);
						}
						onComplete(object.children);
					}, function(error){
					    onComplete([]);
						console.log(error.responseText);
			 	 });
			 
				return;
			}
			if(object.children==true){ 
			 
				this.get(object.identifier + this.subpath)
						.then(function(data){
					object.children = [];
				    for(var i=0; i<data.length; i++){  
						object.children.push (data[i]);
					}
					onComplete(object.children);
				}, function(error){
					// an error occurred, log it, and indicate no children
					console.error(error);
					onComplete([]);
				});		
			}else{
				// already loaded
				onComplete(object.children);
			}
		},
		
		get: function(_searchPath){
		
		 	return xhr.post({
					  // The URL of the request
				    url: dojo.config.em4cServer + "/updatews/cognos/getContentStore?",
				    content: { 
				    	campassport:  this.campassport,
				    	searchPath: _searchPath
				    },
				    handleAs: "json"
	        });	
		},		
		
		 
		getRoot: function(onItem, onError){  
			onItem(this.root); 	
		},
	  
		getLabel: function(object){
		 	return object.name;
		},
		
		getIconClass: function(/*dojo.data.Item*/ item, /*Boolean*/ opened){
			 var icon = "dijitLeaf";
			 switch (item.type){
			     case "report":
					 icon = "reportIcon";
					 break;
				 case "package":
					 icon = "packageIcon";
					 break;
				 case "content":
				 case "folder":
					if(opened){
					   icon = "folderOpenIcon";
					}else{
					   icon = "folderIcon";
					}
				    break;
		    }
			return icon;
		}	
	});
	
});