define(["dojo/dom",
		"dojo/dom-style", 
        "dojo/dom-geometry",
        "dojo/_base/fx",
        "dojo/_base/lang", 
        "dijit/form/Button",
        "dijit/layout/BorderContainer",
        "dijit/layout/TabContainer",
        "dijit/layout/ContentPane",
		"./SearchPane",
		"./UpdatePane",
		"./TopPane",
		"./BottomPane"
        ],
	 
 function (dom, domStyle, domGeometry, baseFx, lang, Button, BorderContainer, TabContainer, ContentPane, SearchPane, UpdatePane, TopPane, BottomPane){
	
	return  {
			
		  	load: function () {
			
				this.initUI();			
				this.hideLoading();
			},
			
			initUI: function () {
			 
				// BorderContainer layout 
				var bc = new BorderContainer ({
							design:'headline', 
							gutters:true, 
							liveSplitters:true
						}, "appLayout");

				new ContentPane({
					splitter:true, region: 'top' 
				}, "topbar");
				    
					
				new ContentPane({
					splitter:true, region:'leading'
				}, "leftbar");
				
				new ContentPane({
					 splitter:true, region:'center'
				}, "center");
				
				new ContentPane({
					 splitter:true, region:'bottom'
				}, "bottom");
		
				var search = new SearchPane({}).placeAt(dojo.byId("leftbar"));
				search.startup();
			 
				var top = new TopPane().placeAt(dojo.byId("topbar"));
				top.startup();
				
				var bottom = new BottomPane().placeAt(dojo.byId("bottom"));
				bottom.startup();
				
				bc.startup(); 
			},
			
			showLoading: function () {
				
				 var overlayNode = dom.byId("loadingOverlay");
				 
                if("none" == domStyle.get(overlayNode, "display")) {
		                var coords = domGeometry.getMarginBox(targetNode || win.body());
		                domGeometry.setMarginBox(overlayNode, coords);
		 
		                domStyle.set(dom.byId("loadingOverlay"), {
		                    display: "block",
		                    opacity: 1
		                });
		            }
			},
			
			hideLoading: function () {
				
				 baseFx.fadeOut({
		                node: dom.byId("loadingOverlay"),
		                onEnd: function(node){ 
		                    domStyle.set(node, "display", "none"); 
		                }
		            }).play();
			}	 
	}; 
});